//+------------------------------------------------------------------+
//|                                              Candle Close EA_2.mq5 |
//|                                 Copyright 2016, Hudson Analytics |
//|                                                    NurudeenAmedu |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Hudson Analytics"
#property link      "NurudeenAmedu"
#property version   "1.00"
#include <Trade\Trade.mqh>
CTrade  trade;

input double LotSize = 1.00;
input double DeltaX = 100;
input double TakeProfit = 300;
input double StopLoss = 200;
input bool UseTrailing = true;
input double    TrailStop    = 100;
input double    TrailStep    = 10;
input int MaxSpread = 20;
input int MagicNumber = 53435;


int buytrade, selltrade, n=0;
double btp, stp, bsl, ssl, Close[], lastclose, Ask, Bid;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   //--- set MagicNumber for your orders identification
   trade.SetExpertMagicNumber(MagicNumber);
   
   //--- set available slippage in points when buying/selling
   int deviation=50;
   trade.SetDeviationInPoints(deviation);
   
   //--- logging mode: it would be better not to declare this method at all, the class will set the best mode on its own
   trade.LogLevel(1); 
   
   //--- what function is to be used for trading: true - OrderSendAsync(), false - OrderSend()
   trade.SetAsyncMode(false);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   Ask = SymbolInfoDouble(Symbol(),SYMBOL_ASK);
   Bid = SymbolInfoDouble(Symbol(),SYMBOL_BID);


Comment(OpenPendThisPair(Symbol(),0), " ", OpenPendThisPair(Symbol(),1), " ", OpenOrders(Symbol()));

   int spread =(int)SymbolInfoInteger(Symbol(),SYMBOL_SPREAD);
   
   Ask = SymbolInfoDouble(Symbol(),SYMBOL_ASK);
   Bid = SymbolInfoDouble(Symbol(),SYMBOL_BID);
   
   if(IsNewCandle()){DelAll();buytrade=1; selltrade=1; n++;}


   Checker();
   if(UseTrailing){Trailing();}
   if(buytrade==1 && n>1 && spread<MaxSpread){
      
      double buyprice=iClose(Symbol(),0,1)+(DeltaX*Point());
      
      if(TakeProfit>0){btp=buyprice+(TakeProfit*Point());}else{btp=0;}
      if(StopLoss>0){bsl=buyprice-(StopLoss*Point());}else{bsl=0;}
      
      int buyticket = trade.BuyStop(LotSize,buyprice,Symbol(),bsl,btp,0,0,"EA Trade");
      buytrade=0;
      }
   
   if(selltrade==1 && n>1 && spread<MaxSpread){
      
      double sellprice=iClose(Symbol(),0,1)-(DeltaX*Point());
      
      if(TakeProfit>0){stp=sellprice-(TakeProfit*Point());}else{stp=0;}
      if(StopLoss>0){ssl=sellprice+(StopLoss*Point());}else{ssl=0;}
      
      int sellticket = trade.SellStop(LotSize,sellprice,Symbol(),ssl,stp,0,0,"EA Trade");
      selltrade=0;
      }   
   
   }
//---

  
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//insuring its a new candle function
//+------------------------------------------------------------------+
bool IsNewCandle()
{
   if(iClose(Symbol(),PERIOD_CURRENT,1)==lastclose){return(false);}
   if(iClose(Symbol(),PERIOD_CURRENT,1)!=lastclose){lastclose=iClose(Symbol(),PERIOD_CURRENT,1);return(true);}
	return(true);
}

//+------------------------------------------------------------------+ 
//| Get the Close for specified bar index                             | 
//+------------------------------------------------------------------+ 
double iClose(string symbol,ENUM_TIMEFRAMES timeframe,int index) 
  { 
   double close=0; 
   ArraySetAsSeries(Close,true); 
   int copied=CopyClose(symbol,timeframe,0,Bars(symbol,timeframe),Close); 
   if(copied>0 && index<copied) close=Close[index]; 
   return(close); 
  }
  
  int OpenOrders(string symbol){
   int tnum =0;
   int _tp=PositionsTotal();
   
   for(int i=_tp-1; i>=0; i--)
     {
      string _p_symbol=PositionGetSymbol(i);
      ulong tick = PositionGetTicket(i);
      
      if(PositionSelectByTicket(tick)){
      if(_p_symbol==symbol){
      if(MagicNumber==PositionGetInteger(POSITION_MAGIC)){
         tnum++;
         }
    }
    }
    }
return(tnum);
}

int OpenPendThisPair(string symbol, int type){
   int tnum =0;
   int _tp=OrdersTotal();
   
   for(int i=_tp; i>=0; i--)
     {
      
      ulong tick = OrderGetTicket(i);
      
      if(OrderSelect(tick)){
      int ordtyp =(int)OrderGetInteger(ORDER_TYPE);
      long magic =OrderGetInteger(ORDER_MAGIC);
      string _p_symbol=OrderGetString(ORDER_SYMBOL);
   
   if(MagicNumber==magic){
      if(_p_symbol==symbol && ordtyp==4 && type==0){
      
         tnum++;
         
    }
      if(_p_symbol==symbol && ordtyp==5 && type==1){

         tnum++;
         
    }
    }
    }
    }
return(tnum);
}

void DelAll(){
   int _tp=OrdersTotal();
   for(int i=_tp-1; i>=0; i--)
     {
      string _p_symbol=OrderGetString(ORDER_SYMBOL);
      ulong tick=OrderGetTicket(i);
      
      if(OrderSelect(tick)){
      if(MagicNumber==OrderGetInteger(ORDER_MAGIC)){
               
         trade.OrderDelete(tick);        
      
    }
  }
  }
}

void Checker(){
    int _tp=PositionsTotal();
   
   for(int i=_tp-1; i>=0; i--)
     {
      string _p_symbol=PositionGetSymbol(i);
      ulong tick = PositionGetTicket(i);
      
      if(PositionSelectByTicket(tick)){
         double ordtp = PositionGetDouble(POSITION_TP);
         double ordsl = PositionGetDouble(POSITION_SL);
         ENUM_POSITION_TYPE ordtype =(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);
         
      if(ordtype==POSITION_TYPE_BUY && ((Bid>ordtp && ordtp!=0)||(Bid<ordsl))){
         trade.PositionClose(tick,-1);
            }
            
      if(ordtype==POSITION_TYPE_SELL && ((Ask<ordtp)||(Ask>ordsl && ordsl!=0))){
         trade.PositionClose(tick,-1);
            }
        }
    }
}


void Trailing(){
double newsl;
   int _tp=PositionsTotal();
   for(int i=_tp-1; i>=0; i--)
     {
      ulong tick=PositionGetTicket(i);

      if(PositionGetString(POSITION_SYMBOL)==_Symbol && MagicNumber==PositionGetInteger(POSITION_MAGIC)) // Add here needed filters : symbol ? magic ?
        {
         double _p_tp = PositionGetDouble(POSITION_TP);
         double _p_sl = PositionGetDouble(POSITION_SL);
         double _p_op = PositionGetDouble(POSITION_PRICE_OPEN);
         long _p_type = PositionGetInteger(POSITION_TYPE);

         if(_p_type==POSITION_TYPE_BUY && ((Ask-_p_op)>TrailStop*Point()))
           {
            newsl=Ask-(TrailStep*Point());
            if(newsl>_p_sl && newsl!=_p_sl)
              {
               trade.PositionModify(_Symbol,newsl,_p_tp);
              }
           }

         if(_p_type==POSITION_TYPE_SELL && (_p_op-Bid>TrailStop*Point()))
           {
            newsl=Bid+(TrailStep*Point());
            if((_p_sl>newsl || _p_sl==0) && newsl!=_p_sl)
              {
               trade.PositionModify(_Symbol,newsl,_p_tp);
              }
           }
        }
     }
}

double totalVolume(){
   double volume =0;
   int _tp=PositionsTotal();
   
   for(int i=_tp-1; i>=0; i--)
     {
      string _p_symbol=PositionGetSymbol(i);
      ulong tick = PositionGetTicket(i);
      
      if(PositionSelectByTicket(tick)){
      if(_p_symbol==Symbol()){
      if(MagicNumber==PositionGetInteger(POSITION_MAGIC)){
         volume+=PositionGetDouble(POSITION_VOLUME);
         }
    }
    }
    }
return(volume);
}


void CLOSEALL(int type){
   int _tp=PositionsTotal();
   for(int i=_tp-1; i>=0; i--)
     {
      string _p_symbol=PositionGetSymbol(i);
      ulong tick=PositionGetTicket(i);
      
      if(PositionSelectByTicket(tick)){
      
      if(MagicNumber==PositionGetInteger(POSITION_MAGIC)){
      
      if(type==0 && PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY){
         
         trade.PositionClose(tick,-1);
         }
      if(type==1 && PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL){
         
         trade.PositionClose(tick,-1);
         }
  }
}
}
}
